// =====================================================================================================================
//  fennec, a free and open source game engine
//  Copyright © 2025  Medusa Slockbower
//
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program.  If not, see <https://www.gnu.org/licenses/>.
// =====================================================================================================================

#include <stdlib.h>

using assert_handler = void (*)(const char *, const char *, int , const char *);

static assert_handler __priv_handler = nullptr;

void set_assert_handler(assert_handler handler)
{
	__priv_handler = handler;
}

void __assert_impl(const char* expression, const char* file, int line, const char* function)
{
	if (__priv_handler)
		__priv_handler(expression, file, line, function);

	abort();
}