// =====================================================================================================================
//  fennec, a free and open source game engine
//  Copyright © 2025  Medusa Slockbower
//
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program.  If not, see <https://www.gnu.org/licenses/>.
// =====================================================================================================================

#ifndef FENNEC_TEST_LANG_BITS_H
#define FENNEC_TEST_LANG_BITS_H

#include <fennec/lang/assert.h>
#include <fennec/lang/bits.h>

#include "../../test.h"

namespace fennec
{

namespace test
{

void fennec_test_lang_bits()
{
	int a = 0x48ef13ad;
	int b = 0x23e5ab9c;

	fennec_test_run(fennec::bit_cast<float>(0x3ee00000), 0.4375f);

	fennec_test_run(*static_cast<int*>(fennec::bit_and(&a, &b, sizeof(int))), 0x48ef13ad & 0x23e5ab9c);
	fennec_test_run(*static_cast<int*>(fennec::bit_or(&a, &b, sizeof(int))),  (0x48ef13ad & 0x23e5ab9c) | 0x23e5ab9c);
	fennec_test_run(*static_cast<int*>(fennec::bit_xor(&a, &b, sizeof(int))), ((0x48ef13ad & 0x23e5ab9c) | 0x23e5ab9c) ^ 0x23e5ab9c);
}

}

}

#endif // FENNEC_TEST_LANG_BITS_H
